'use strict';var T=require('sortablejs'),A=require('cascaderjs'),i18nJs=require('i18n-js');function _interopDefault(e){return e&&e.__esModule?e:{default:e}}var T__default=/*#__PURE__*/_interopDefault(T);var A__default=/*#__PURE__*/_interopDefault(A);function $(a){return typeof a=="string"&&["not","and","or"].includes(a)}function g(a){if(!Array.isArray(a)||a.length!==3||a[0]!=="="||typeof a[1]!="string")return  false;let e=a[2];return typeof e=="string"||typeof e=="number"||typeof e=="boolean"||Array.isArray(e)}function S(a){return Array.isArray(a)&&a.length===2&&a[0]==="not"&&p(a[1])}function C(a){if(!Array.isArray(a)||a.length<2)return  false;let[e,...r]=a;return (e==="and"||e==="or")&&r.every(o=>p(o))}function p(a){return S(a)||C(a)||g(a)}function b(a){return typeof a=="object"&&a!==null&&typeof a.verbose_name=="string"&&typeof a.class=="string"&&(a.choices===null||Object.prototype.toString.call(a.choices)==="[object Object]"&&Object.values(a.choices).every(e=>typeof e=="string"))}var w={operator:{not:"\u5426",and:"\u540C\u65F6\u6EE1\u8DB3",or:"\u5176\u4E00\u6EE1\u8DB3"},"operator-tip":{not:"\u5BF9\u6761\u4EF6\u7684\u5426\u5B9A/\u53D6\u53CD",and:"\u540C\u65F6\u6EE1\u8DB3\u62EC\u53F7\u5185\u7684\u6240\u6709\u6761\u4EF6",or:"\u6EE1\u8DB3\u62EC\u53F7\u5185\u7684\u6761\u4EF6\u4E4B\u4E00"},delete:"\u5220\u9664","toggle-not":"\u5207\u6362\u201C\u5426\u201D\u7B26\u53F7",fieldSelector:{placeholder:"\u8BF7\u9009\u62E9\u4E00\u4E2A\u5B57\u6BB5"},lookup:{exact:"\u7B49\u4E8E",iexact:"\u7B49\u4E8E\uFF08\u4E0D\u533A\u5206\u5927\u5C0F\u5199\uFF09",isnull:"\u4E3A\u7A7A",gt:"\u5927\u4E8E",gte:"\u5927\u4E8E\u6216\u7B49\u4E8E",lt:"\u5C0F\u4E8E",lte:"\u5C0F\u4E8E\u6216\u7B49\u4E8E",contains:"\u5305\u542B",icontains:"\u5305\u542B\uFF08\u4E0D\u533A\u5206\u5927\u5C0F\u5199\uFF09",startswith:"\u4EE5...\u5F00\u59CB",istartswith:"\u4EE5...\u5F00\u59CB\uFF08\u4E0D\u533A\u5206\u5927\u5C0F\u5199\uFF09",endswith:"\u4EE5...\u7ED3\u675F",iendswith:"\u4EE5...\u7ED3\u675F\uFF08\u4E0D\u533A\u5206\u5927\u5C0F\u5199\uFF09",regex:"\u6B63\u5219\u8868\u8FBE\u5F0F\u5339\u914D",iregex:"\u6B63\u5219\u8868\u8FBE\u5F0F\u5339\u914D\uFF08\u4E0D\u533A\u5206\u5927\u5C0F\u5199\uFF09"},"add-new":"\u521B\u5EFA\u4E00\u4E2A\u65B0\u7684\u6761\u4EF6\u6216\u6761\u4EF6\u96C6\u5408","add-new-and-group":"\u521B\u5EFA\u201C\u540C\u65F6\u6EE1\u8DB3\u201D\u6761\u4EF6\u96C6\u5408","add-new-or-group":"\u521B\u5EFA\u201C\u5176\u4E00\u6EE1\u8DB3\u201D\u6761\u4EF6\u96C6\u5408","add-new-condition":"\u521B\u5EFA\u4E00\u4E2A\u65B0\u7684\u6761\u4EF6","button-symbol":{N:"\u5426"}};var h=new i18nJs.I18n({en:{operator:{not:"Not",and:"And",or:"Or"},"operator-tip":{not:"Negation of the following condition",and:"Must meet all conditions in parentheses",or:"Must meet any one condition in parantheses"},delete:"Delete","toggle-not":"Toggle not operator",fieldSelector:{placeholder:"Select a field"},lookup:{exact:"equals",iexact:"equals (case-insensitive)",isnull:"is null",gt:"is greater than",gte:"is greater than or equal to",lt:"is less than",lte:"is less than or equal to",contains:"contains",icontains:"contains(case-insensitive)",startswith:"starts with",istartswith:"starts with(case-insensitive)",endswith:"ends with",iendswith:"ends with(case-insensitive)",regex:"matches(regular expression)",iregex:"matches(regular expression, case-insensitive)"},"add-new":"Add a new group or condition","add-new-and-group":"Add a new `And` group","add-new-or-group":"Add a new `Or` group","add-new-condition":"Add a new condition","button-symbol":{N:"N"}},zh:{...w}});h.defaultLocale="en";h.enableFallback=true;function s(...a){return h.locale=navigator.language,h.t(...a)}var u=class{element;isEditing=false;selectElement=null;options=[{value:"and",display:"And"},{value:"or",display:"Or"}];constructor(e){this.element=e,this.toggleEdit();}createSelect(){let e=document.createElement("div");e.className="dlf:absolute dlf:bg-white dlf:border dlf:border-gray-300 dlf:rounded dlf:shadow-lg dlf:z-50",this.options.forEach(o=>{let t=document.createElement("div");t.className=`dlf-operator dlf-${o.value}-operator
          dlf:cursor-pointer dlf:p-2 dlf:hover:bg-gray-100`,t.textContent=o.display,t.setAttribute("data-value",o.value),t.addEventListener("click",i=>{i.stopPropagation(),this.selectOption(o);}),e.appendChild(t);});let r=this.element.getBoundingClientRect();return e.style.top=`${r.bottom}px`,e.style.left=`${r.left}px`,e}toggleEdit(){if(!this.isEditing){this.isEditing=true,this.selectElement=this.createSelect(),document.body.appendChild(this.selectElement);let e=r=>{this.selectElement&&!this.selectElement.contains(r.target)&&(this.closeSelect(),document.removeEventListener("click",e));};setTimeout(()=>{document.addEventListener("click",e);},0);}}closeSelect(){this.selectElement&&(this.selectElement.remove(),this.selectElement=null),this.isEditing=false;}selectOption(e){this.element.textContent=e.display,this.element.className=`dlf-operator dlf-${e.value}-operator dlf:tooltip`,this.element.setAttribute("data-value",e.value),this.element.setAttribute("data-tip",e.display),this.closeSelect();}};function x(a,e,r=new Set){let o=[],t=e[a];if(!t)return o;r.add(a);let i=t.__rel;for(let[l,n]of Object.entries(i)){let c=n.model;if(!r.has(c)){let d=e[c];d&&o.push({value:l,label:n.verbose_name??d.__verbose_name,children:x(c,e,new Set(r).add(c))});}}for(let[l,n]of Object.entries(t))if(!(l==="__rel"||l==="__verbose_name")){if(!b(n))throw new Error(`Wrong schema! ${n} should be of SchemaField type!`);o.push({value:l,label:n.verbose_name});}return o}function v(a,e,r){if(a.length===0)throw new Error("fieldNames array must not be empty");let o=r[e];for(let t=0;t<a.length;t++){let i=a[t];if(t!==a.length-1){if(o[i])throw new Error(`Field '${i}' should not be a SchemaField in model`);let l=r[o.__rel[i].model];if(!l)throw new Error(`Model '${i}' not found in schema`);o=l;}else {let l=o[i];if(!b(l))throw new Error(`Wrong schema! '${i}' should be a SchemaField`);return l}}throw new Error("Unexpected end of function execution")}var y=".dlf-field-selector:not(:has(> .cascader-container))",O=" > ";function z(a,e,r){if(e.choices){let l=document.createElement("select");l.className="dlf-select";for(let[n,c]of Object.entries(e.choices)){let d=document.createElement("option");d.value=n,d.label=c,l.append(d);}return r&&r in e.choices&&(l.value=r),l}let o=document.createElement("input");o.className="dlf-input",r&&(o.value=r);let t=e.class,i="";switch(t){case "AutoField":case "BigAutoField":case "BigIntegerField":case "SmallAutoField":case "SmallIntegerField":case "DecimalField":case "DurationField":case "FloatField":case "IntegerField":case "PositiveBigIntegerField":case "PositiveIntegerField":case "PositiveSmallIntegerField":case "URLField":case "UUIDField":i="number";break;case "BooleanField":i="checkbox";break;case "CharField":case "EmailField":case "FileField":case "FilePathField":case "GenericIPAddressField":case "ImageField":case "SlugField":case "TextField":i="text";break;case "DateField":i="date";break;case "DateTimeField":i="datetime-local";break;case "TimeField":i="time";break}return a=="isnull"&&(i="checkbox"),o.type=i,o}var E=class{container;expression;schema;mainModel;fieldsList;getValueInputFn;constructor(e){let r=typeof e.container=="string"?document.querySelector(e.container):e.container;if(!r)throw Error(`Cannot find element ${e.container}`);this.container=r,this.expression=e.initialExpression||["and"],this.schema=e.schema,this.mainModel=e.mainModel,this.fieldsList=x(this.mainModel,this.schema.models),this.getValueInputFn=e.getValueInputFn??z,this.init();}init(){for(this.render(this.expression),this.setupEventListener();this.setupNewCascaderSelect(););this.setupSortableForGroup(this.container.querySelector(".dlf-group-body-conditions"));}setupSortableForGroup(e){T__default.default.create(e,{group:"dlf-sortable",filter:".dlf-sortable-ignore",swapThreshold:.65,draggable:".dlf-sortable",ghostClass:"dlf-sortable-ghost",chosenClass:"",dragClass:""});}setupNewCascaderSelect(){let e=document.querySelector(y);if(!e)return null;let r=e.getAttribute("data-initial-value"),o;r&&(o=r.split(","));let t,i=new A__default.default(y,{mode:"single",placeholder:s(["fieldSelector","placeholder"]),data:this.fieldsList,showClear:false,defaultValue:o,onChange:(l,n,c)=>{if(l.length&&t!=l){let d=v(l,this.mainModel,this.schema.models);this.setupLookupSelector(e.parentElement,d);}t=l,e.setAttribute("data-value",l.toString());},displayRender(l){return l.join(O)}});if(i.init(),o){let l=v(o,this.mainModel,this.schema.models);this.setupLookupSelector(e.parentElement,l),e.removeAttribute("data-initial-value"),e.setAttribute("data-value",o.toString());}return i}setupLookupSelector(e,r){let o=this.schema.lookups[r.class],t=e.querySelector(".dlf-lookup-selector"),i=e.querySelector(".dlf-value-input"),l=document.createElement("select");l.className="dlf-select",o.forEach(c=>{let d=document.createElement("option");d.value=c,d.label=s(["lookup",c]),l.append(d);});let n=t.getAttribute("data-initial-value");n&&(o.includes(n)?l.value=n:console.error(`The initial_value ${n} is not in lookups! Element:`,t),t.removeAttribute("data-initial-value")),t.replaceChildren(l),i.replaceChildren(),this.setupValueInput(e,r,l.value),l.addEventListener("change",()=>{this.setupValueInput(e,r,l.value);});}setupValueInput(e,r,o){let t=e.querySelector(".dlf-value-input"),i=t.getAttribute("data-initial-value"),l=this.getValueInputFn(o,r,i);t.removeAttribute("data-initial-value"),t.replaceChildren(l);}render(e){this.container.innerHTML=`
    <div class="dlf-root-container">
      ${this.renderExpression(e)}
    </div>
    `;}renderExpression(e){let r=false,[o,...t]=e;if(o==="not"){if(t.length!==1)throw new Error("NOT expression must have exactly one subexpression");r=true;let l=t[0];[o,...t]=l;}if(o=="="){let l=[o,...t];if(!g(l))throw Error(`${l} is a valid LispyConditionExpr!`);return this.renderCondition(true,l)}let i=t.map(l=>{if(!p(l))throw new Error(`${l} is not a valid LispyExpression`);return l[0]=="="?this.renderCondition(false,l):this.renderExpression(l)}).join("");return `
    <div class="dlf-group dlf-sortable dlf-expanded dlf:group/group">
      <div class="dlf-group-prefix">
        ${r?this.renderOperator("not"):""}
        ${this.renderOperator(o)}
        <div class="dlf-group-collapse">
          <span class="dlf-parenthesis">(</span>
          <span class="dlf-ellipsis">...</span>
          <span class="dlf-parenthesis">)</span>
        </div>          
        <div class="dlf-group-hover-visible dlf:gap-2 dlf:flex dlf:items-center">
          ${this.renderCommonActions()}
        </div>
      </div>
        
      <div class="dlf-group-body">
        <div class="dlf-group-body-conditions">
          ${i}
        </div>
        <div class="dlf-group-body-actions dlf:relative dlf:px-2 dlf-sortable-ignore">
          <div title="${s("add-new")}" >
            <button class="dlf-icon-button" data-action="add-new">
              <svg xmlns="http://www.w3.org/2000/svg" fill="none"
                viewBox="0 0 24 24" stroke-width="2.5" stroke="currentColor"
                class="dlf:size-4">
                <path stroke-linecap="round" stroke-linejoin="round" d="M12 4.5v15m7.5-7.5h-15" />
              </svg>
            </button>
          </div>
        </div>
      </div>
      <div class="dlf-parenthesis">)</div>
    </div>
    `}renderOperator(e){let r=s(["operator-tip",e]);return `
    <span class="dlf-operator dlf-${e}-operator" title="${r}"
      data-value="${e}">
      ${s(["operator",e])}
    </span>
    `}renderCondition(e=false,r){let o;if(r){let t=r[1].split("__"),i=t.slice(0,-1),l=t.slice(-1)[0],n=r[2];if(typeof n=="object")throw new Error(`Currently doesn't support ${n} in LispyConditionExpr`);o=`
<div class="dlf-condition-input-container dlf:flex dlf:gap-2 dlf:items-center" >
  <div class="dlf-field-selector" data-initial-value="${i}"></div>
  <div class="dlf-lookup-selector" data-initial-value="${l}"></div>
  <div class="dlf-value-input" data-initial-value="${n}"></div>
</div>
`;}else o=`
<div class="dlf-condition-input-container dlf:flex dlf:gap-2 dlf:items-center" >
  <div class="dlf-field-selector"></div>
  <div class="dlf-lookup-selector"></div>
  <div class="dlf-value-input"></div>
</div>
`;return `
    <div class="dlf-condition dlf:group/condition dlf-sortable">
      ${e?this.renderOperator("not"):""}
      ${o}
      
      <div class="dlf:invisible dlf:group-hover/condition:visible dlf:gap-2 dlf:flex dlf:items-center">
        ${this.renderCommonActions()}
      </div>
    </div>
    `}renderCommonActions(){return `
<div title="${s("delete")}">
  <button class="dlf-icon-button" data-action="delete">
    <svg xmlns="http://www.w3.org/2000/svg" fill="none" viewBox="0 0 24 24"
      stroke-width="2.5" stroke="currentColor"
      class="dlf:size-4">
        <path stroke-linecap="round" stroke-linejoin="round" d="M6 18 18 6M6 6l12 12" />
    </svg>
  </button>
</div>

<div title="${s("toggle-not")}" >
  <button class="dlf-icon-button"
    data-action="toggle-not">${s(["button-symbol","N"])}
  </button>
</div>
`}setupEventListener(){this.container.addEventListener("click",e=>{let r=e.target;if(r.closest(".dlf-group-collapse")){let i=r.closest(".dlf-group");i&&i.classList.toggle("dlf-expanded");return}let o=r.closest("button");if(o){switch(o.dataset.action){case "add-new":this.actionAddNew(o);break;case "delete":this.actionDelete(o);break;case "toggle-not":this.actionToggleNot(o);break}return}let t=r.closest(".dlf-operator");t&&!t.classList.contains("dlf-not-operator")&&new u(t);});}actionDelete(e){let r=e.closest(".dlf-condition");r||(r=e.closest(".dlf-group")),r.remove(),this.container.firstElementChild.children.length||(this.render(["and"]),this.setupSortableForGroup(this.container.querySelector(".dlf-group-body-conditions")));}actionAddNew(e){let r=e.parentElement.parentElement;if(r.querySelector(".dlf-popup-menu"))return;let o=document.createElement("div");o.className="dlf-popup-menu",o.innerHTML=`
<ul>
  <li><a data-action="add-new-and-group">${s("add-new-and-group")}</a></li>
  <li><a data-action="add-new-or-group">${s("add-new-or-group")}</a></li>
  <li><a data-action="add-new-condition">${s("add-new-condition")}</a></li>
</ul>
`;let t=new AbortController,i=l=>{let n=l.target;if(!o.isConnected)return;let c=o.contains(n),d=e.contains(n);!c&&!d&&(o.remove(),t.abort());};document.addEventListener("click",i,{signal:t.signal}),o.querySelectorAll("a").forEach(l=>{l.addEventListener("click",()=>{let n=l.getAttribute("data-action"),c=r.previousElementSibling;switch(n){case "add-new-and-group":this.addNewGroup("and",c);break;case "add-new-or-group":this.addNewGroup("or",c);break;case "add-new-condition":this.addNewCondition(c);break}o.remove(),t.abort();},{signal:t.signal});}),e.parentElement.insertAdjacentElement("afterend",o);}addNewGroup(e,r){let o=[e],t=this.renderExpression(o);r.insertAdjacentHTML("beforeend",t);let i=r.lastElementChild;this.setupSortableForGroup(i.querySelector(".dlf-group-body-conditions"));}addNewCondition(e){let r=this.renderCondition();e.insertAdjacentHTML("beforeend",r),this.setupNewCascaderSelect();}actionToggleNot(e){let r=e.closest(".dlf-condition"),o=null;if(r?o=r:o=e.closest(".dlf-group-prefix"),!o)throw new Error("While executing 'toggle-not' action, parent element canot be found!");let t=o.querySelector(".dlf-not-operator");t?t.remove():o.insertAdjacentHTML("afterbegin",this.renderOperator("not"));}toJson(){let e=this.container.querySelector(".dlf-group");return e?this.parseGroup(e):["and"]}parseGroup(e){let r=e.firstElementChild.querySelectorAll(".dlf-operator"),o=false,t="and";r.forEach(c=>{let d=c.getAttribute("data-value");switch(d){case "not":o=true;break;case "and":case "or":t=d;break}});let i=e.querySelector(".dlf-group-body-conditions"),l=Array.from(i.children).filter(c=>c.classList.contains("dlf-condition")||c.classList.contains("dlf-group")).map(c=>c.classList.contains("dlf-condition")?this.parseCondition(c):this.parseGroup(c)),n=[t,...l];return o?["not",n]:n}parseCondition(e){let r=!!e.querySelector(".dlf-not-operator"),o=e.querySelector(".dlf-condition-input-container"),t=o.firstElementChild,i=o.children[1],l=o.lastElementChild,n=t.getAttribute("data-value");if(!n)throw new Error("Field selector has not 'data-value` attribute!");let c=n.replaceAll(",","__"),d=i.firstElementChild;if(!d)throw new Error("Misses lookupSelectorElem!");let _=d.value,m=l.firstElementChild;if(!m)throw new Error("Misses valueInputElem!");let L=m.type,f=m.value;switch(L){case "datetime-local":f=new Date(f).toISOString();break;case "number":f=Number(f);break;case "checkbox":f=f=="on";break}let k=["=",`${c}__${_}`,f];return r?["not",k]:k}};exports.FilterEditor=E;exports.getValueInput=z;exports.isLispyAndOrExpr=C;exports.isLispyConditionExpr=g;exports.isLispyExpression=p;exports.isLispyNotExpr=S;exports.isLispyOperator=$;exports.isSchemaField=b;//# sourceMappingURL=lib.js.map
//# sourceMappingURL=lib.js.map